---
- name: Perform Common Tasks
  block:
    - name: Populate service facts
      service_facts:

    - name: Set Hostname if not correct
      hostname:
        name: "{{ inventory_hostname }}"
      when:
        - cloud_provider == 'aws'
        - ansible_hostname != inventory_hostname
      tags: hostname

    - name: Setup Packages
      import_tasks: packages_setup.yml
      tags: packages

    # https://about.gitlab.com/blog/2019/11/15/tracking-down-missing-tcp-keepalives/
    - name: Configure TCP keepalive settings
      sysctl:
        name: net.ipv4.tcp_keepalive_time
        value: '300'
        sysctl_set: true
        state: present
        reload: true
      tags: sysctl

    - name: Mount any data disks
      block:
        - name: Mount data disk if given (legacy)  # Deprecated
          import_tasks: data_disk_legacy.yml
          when: data_disk is defined

        - name: Get Group Data Disks Config
          set_fact:
            group_data_disks: "{{ lookup('vars', gitlab_node_type + '_data_disks', default=[]) }}"
          tags: nvme

        - name: Mount data disks
          import_tasks: data_disks.yml
          when: group_data_disks | length > 0
      when: cloud_provider != 'none'
      tags: data_disks

    - name: Add GitLab repository GPG key
      apt_key:
        url: https://packages.gitlab.com/gpg.key
        state: present
      register: result
      retries: 2
      delay: 3
      until: result is success
      when:
        - omnibus_node
        - ansible_facts['os_family'] == "Debian"
      tags: gpg

    # Removes the official release repo if it's present as we typically want to stick with Nightly
    # Prevents apt from switching to the release channel (when an official release is younger than nightly)
    - name: Ensure only GitLab Nightly apt repo is installed unless specified otherwise
      file:
        path: /etc/apt/sources.list.d/gitlab_gitlab-ee.list
        state: absent
      when:
        - omnibus_node
        - gitlab_repo_script_url != "https://packages.gitlab.com/install/repositories/gitlab/gitlab-ee/script.deb.sh"
        - ansible_facts['os_family'] == "Debian"

    # Allows GET to run on a node after running gitlab-ctl cleanse. The current behavior of cleanse is to
    # delete the /etc/gitlab folder, this will cause an error when we try to copy files to the dir.
    # GitLab Issue: https://gitlab.com/gitlab-org/omnibus-gitlab/-/issues/5814
    - name: Ensure /etc/gitlab dir exists with correct permissions
      file:
        path: /etc/gitlab
        owner: root
        group: root
        mode: 0775
        state: directory
      when: omnibus_node

    # Workaround for https://gitlab.com/gitlab-org/omnibus-gitlab/-/issues/6364
    - name: Create skip-unmigrated-data-check file
      file:
        path: /etc/gitlab/skip-unmigrated-data-check
        state: touch
      when: omnibus_node

    - name: Get GitLab json config file stats if it exists
      stat:
        path: "/opt/gitlab/embedded/nodes/{{ ansible_fqdn }}.json"
      register: gitlab_json_config_file
      tags: reconfigure

    - name: Delete GitLab json config file if malformed
      file:
        path: "/opt/gitlab/embedded/nodes/{{ ansible_fqdn }}.json"
        state: absent
      when:
        - gitlab_json_config_file.stat.exists
        - gitlab_json_config_file.stat.size < 500
      tags: reconfigure

    - name: Download GitLab repository installation script
      get_url:
        url: "{{ gitlab_repo_script_url }}"
        dest: "{{ gitlab_repo_script_path }}"
        force: true
      register: repo_file
      retries: 20
      delay: 30
      when: omnibus_node

    - name: Install GitLab repository
      command: bash /tmp/gitlab_install_repository.sh
      retries: 2
      delay: 10
      until: result is success
      when:
        - omnibus_node
        - repo_file.changed

    - name: Unlock GitLab package installs
      command: apt-mark install gitlab-ee
      register: result
      retries: 2
      delay: 3
      until: result is success
      when:
        - omnibus_node
        - ansible_facts['os_family'] == "Debian"

    # Install GitLab Package via repo. State of latest means always run apt install
    # If gitlab_version is passed then this will always install that version
    - name: Install GitLab repo package
      apt:
        name: "{{ gitlab_repo_package }}"
        state: "{{ 'present' if gitlab_version != '' else 'latest' }}"
      register: result
      retries: 2
      delay: 3
      until: result is success
      when:
        - omnibus_node
        - gitlab_repo_package != ''
        - gitlab_deb_download_url == ''
        - gitlab_deb_host_path == ''
        - ansible_facts['os_family'] == "Debian"

    - name: Download GitLab deb package
      get_url:
        url: "{{ gitlab_deb_download_url }}"
        dest: "{{ gitlab_deb_target_path }}"
        force: true
        headers: "{{ gitlab_deb_download_url_headers }}"
      when:
        - omnibus_node
        - gitlab_deb_download_url != ''
        - ansible_facts['os_family'] == "Debian"

    - name: Copy GitLab deb package
      copy:
        src: "{{ gitlab_deb_host_path }}"
        dest: "{{ gitlab_deb_target_path }}"
        mode: 0755
        force: true
      when:
        - omnibus_node
        - gitlab_deb_host_path != ''
        - ansible_facts['os_family'] == "Debian"

    - name: Install GitLab deb package
      apt:
        deb: "{{ gitlab_deb_target_path }}"
        force: "{{ gitlab_deb_force_install }}"
      when:
        - omnibus_node
        - (gitlab_deb_host_path != '') or (gitlab_deb_download_url != '')
        - ansible_facts['os_family'] == "Debian"

    - name: Lock GitLab package updates
      command: apt-mark hold gitlab-ee
      register: result
      retries: 2
      delay: 10
      until: result is success
      when:
        - omnibus_node
        - ansible_facts['os_family'] == "Debian"
      tags: packages

    - name: Configure sshguard whitelist if present
      block:
        - name: Add internal cidr to sshguard whitelist
          lineinfile:
            path: /etc/sshguard/whitelist
            regexp: "^{{ internal_cidr_16 }}$"
            line: "{{ internal_cidr_16 }}"
          register: sshguard_whitelist

        - name: Restart sshguard
          service:
            name: sshguard
            state: restarted
          when: sshguard_whitelist.changed
      when: "'sshguard' in services"

    - name: Upgrade Packages
      import_tasks: packages_upgrade.yml
      tags: packages

    - name: Mark common has run
      set_fact:
        common_performed: true
  when: common_performed is not defined
